<?php
	/*
	* 2018 - VEGA Informatique
	*
	* NOTICE OF LICENSE
	*
	* This source file is subject to the Open Software License (OSL 3.0)
	* that is bundled with this package in the file LICENSE.txt.
	* It is also available through the world-wide-web at this URL:
	* http://opensource.org/licenses/osl-3.0.php
	*
	* DISCLAIMER
	*
	* Do not edit or add to this file if you wish to upgrade PolarisLink to newer
	* versions in the future. 
	*
	*  @author VEGA Informatique <contact@vega-info.fr>
	*  @copyright  2018 VEGA Informatique
	*  @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
	*/

	class PolarisLinkJobs extends ObjectModel
	{
		public $id_link;
		public $job;
		public $priority;
		public $creation_date;
		public $rows_done;
		public $total_rows;	
		public $err;
		public $progress;
		public $rcats;
		public $finished = 0;

		public $details = [];
		public $rebuild_categories = [];
	
		public static $definition = array(
				"table" => "polarislink_jobs",
				"primary" => "id_job",
				"multilang" => false,
				"fields" => array(
								"id_link" => array( "type" => ObjectModel::TYPE_INT ),									
								"job" => array( "type" => ObjectModel::TYPE_STRING ),	
								"finished" => array( "type" => ObjectModel::TYPE_INT ),	
								"priority" => array( "type" => ObjectModel::TYPE_INT ),	
								"creation_date" => array( "type" => ObjectModel::TYPE_INT ),	
								"rows_done" => array( "type" => ObjectModel::TYPE_INT ),	
								"total_rows" => array( "type" => ObjectModel::TYPE_INT ),	
								"progress" => array( "type" => ObjectModel::TYPE_STRING ),	
								"rcats" => array( "type" => ObjectModel::TYPE_STRING ),	
								"err" => array( "type" => ObjectModel::TYPE_INT ),	
							),
			);

		public static function loadAll($id_link = null)
		{			
			$sql = "SELECT * FROM " . _DB_PREFIX_ . "polarislink_jobs";
			if ($id_link) 
				$sql .= " WHERE id_link = ".pSQL($id_link);
			
			$list = [];
			if ($rows = Db :: getInstance()->ExecuteS($sql))
			{			
				foreach (ObjectModel :: hydrateCollection(__CLASS__, $rows) as $result)
				{					
					$result->details = json_decode($result->progress, true);
					$result->rebuild_categories = json_decode($result->rcats, true);
					$list[] = $result;
				}				
			}

			return $list;
		}
			
		/* chercher par propriété */
		public static function loadByJobName($id_link, $jobName)
		{
			$sql = "SELECT * FROM " . _DB_PREFIX_ . "polarislink_jobs WHERE id_link = ".pSQL($id_link)." AND job = '".pSQL($jobName)."'";
			
			if ($rows = Db :: getInstance()->ExecuteS($sql)) 
			{
				foreach (ObjectModel :: hydrateCollection(__CLASS__, $rows) as $result)
				{
					$result->details = json_decode($result->progress, true);
					$result->rebuild_categories = json_decode($result->rcats, true);
					return $result;
				}
			}

			return NULL;
		}

		/**
		 * 
		 */
		public function add($auto_date = true, $null_values = false)
    	{			
			$this->rcats = json_encode($this->rebuild_categories);
			$this->progress = json_encode($this->details);
			if ($this->rows_done > $this->total_rows)
				$this->rows_done = $this->total_rows;

        	return parent::add($auto_date, $null_values);
		}

		/**
		 * 
		 */
		public function update($null_values = false)
    	{
			$this->rcats = json_encode($this->rebuild_categories);
			$this->progress = json_encode($this->details);
			if ($this->rows_done > $this->total_rows)
				$this->rows_done = $this->total_rows;

        	return parent::update($null_values);
		}
	}
?>